function Yct=CommonTrendM(Y,P,Lmax,weight)
%
%   input  Y  : Q*PxN (P=Py, not true P), weight: Qx1
%   output Yct: QxNT
%
[Pw, N]=size(Y);
Q=Pw/P;
Lmax2=2*Lmax;
NT=N-Lmax2;
if P==1
    Yct=Y(:,Lmax+1:N-Lmax);
else
    %% reform (rearrange)
    W=[];
    for q=1:Q
        for p=1:P
            W(q,p,:)=Y((p-1)*Q+q,:);
        end
        Ytmp=squeeze(W(q,:,:));
        Yctmp=sum(Ytmp)/P;
        Yctmp=Yctmp(Lmax+1:N-Lmax);
        Yct(q,:)=Yctmp;
    end

    R=ones(P,Q)/P;
    Lag=zeros(P,1);
    dsmin=fun_dsmCTm(W,Yct,R,Lag,Lmax,weight); % W:QxPxN, Yct:QxNT, R:PxQ
    Yct0=Yct;
    for count=1:10
        Rold=R;
        Lag=zeros(P,1);
        for p=1:P
            y=squeeze(W(:,p,:)); 
            [sm,r,lg]=fun_dsmTm(Yct,y,Lmax,weight); % Yct:QxNT, y:QxN, r:1xQ     
            Lag(p)=lg;
            r=max(0,r);
            R(p,:)=r;
        end
        Yct=zeros(Q,NT);
        for q=1:Q
            R(:,q)=R(:,q)/sum(R(:,q));
        end
        for p=1:P
            y=squeeze(W(:,p,:)); 
            for q=1:Q
                Yct(q,:)=Yct(q,:)+R(p,q)*y(q,Lmax+1+Lag(p):N-Lmax+Lag(p));
            end
        end
        ds=fun_dsmCTm(W,Yct,R,Lag,Lmax,weight);
        if ds < dsmin
            dsmin=ds;
            Yct0=Yct;
        end
    end
    Yct=Yct0;
end
