%  auxiliary program based on files generated by KMTm1.m
%
%          ( sort and summarize )
%
clear
close all

igraph=0; % 1: plot multivariate series in each object for each cluster
%%%%%%%%%%%%%%%%%%
fname='covid19TK';
load(strcat(fname,'.mat'));
load(strcat(fname,'_res.mat'));
%%%%%%%%%%%%%%%%%%
[P,Q,N]=size(X);
NT=N-2*Lmax;
%  CMT: KxQxNT  R:PxQ

%%% sort
knum=zeros(K,1);
for k=1:K
    knum(k)=sum(kc==k);
end
[tmp,ind]=sort(knum,'descend');
[tmp,ind2]=sort(ind);
kcold=kc;
for p=1:P
    kc(p)=ind2(kcold(p));
end
CMTold=CMT;
for k=1:K
   CMT(k,:,:)=squeeze(CMTold(ind(k),:,:)); 
end

%%% figure 1
for k=1:K
  for q=1:Q
    subplot(K,Q,(k-1)*Q+q)
    hold on
    gmax=0;
    for p=1:P
        n1=Lmax+1+Lag(p);
        n2=N-Lmax+Lag(p);
        if kc(p)==k
            y=squeeze(X(p,q,:));
            gmax=max(gmax,max(R(p,q)*y(n1:n2)));
            plot([N-n2+1:N-n1+1],R(p,q)*y(n1:n2),'b:')
        end
    end
    plot([Lmax+1:N-Lmax],squeeze(CMT(k,q,:)),'r-','LineWidth',1)
    gmax=max(gmax,max(squeeze(CMT(k,q,:))));
    hold off
    box on
    axis([N-n2+1 N-n1+1 0 1.2*gmax])
    title(strcat('k=',num2str(k),'  q=',num2str(q)))
  end
end

Jmin

%%% summary
Pnum=[kc [1:P]' Lag];
disp 'cluster# No.   Lag'
sortrows(Pnum)

knum=zeros(K,1);
for k=1:K
    knum(k)=sum(kc==k);
end
lagAv=zeros(K,1);
lagMax=lagAv;
lagMin=lagAv;
s=1;
for k=1:K
    lagAv(k)=mean(Pnum(s:s+knum(k)-1,3));
    lagMin(k)=min(Pnum(s:s+knum(k)-1,3));
    lagMax(k)=max(Pnum(s:s+knum(k)-1,3));
    s=s+knum(k);
end

disp 'cluseter size,lag mean, lag min, lag max'
[knum lagAv lagMin lagMax]

%%% figure 2
if igraph~=0
    xm=max(max(max(X)))*1.1;
    gmax=max(knum);
    cc=['krbcg'];
    ccn=length(cc);
    if gmax<=20
        spy=2;
        spx=ceil(gmax/spy);
    elseif gmax<=30
        spy=3;
        spx=ceil(gmax/spy);
    else
        spy=4;
        spx=ceil(gmax/spy);
    end
    for k=1:K
        figure
        jn=1;
        for p=1:P
            if kc(p)==k
                subplot(spx,spy,jn)
                y=squeeze(X(p,:,:));
                hold on
                for q=1:Q
    % %                 plot([1:N],y(q,:),cc(1+mod(q,ccn)))
                    plot([1:N],y(q,:)/max(y(q,:))*0.9,cc(1+mod(q,ccn)))
                end
                hold off
    % %             axis([1 N 0 xm]) 
                axis([1 N 0 1])
                box on
                jn=jn+1;
                title(strcat('k=',num2str(k),'  No.',num2str(p)))
            end
        end
    end
end

