function [smmin,rmin,lag]=fun_dsmTm(Yct,y,Lmax,weight)
%
% input  yCT: QxNT(common trend), y: QxN, weight: Qx1
% output rmin:1xQ
%
[Q,N]=size(y);
Lmax2=2*Lmax;
sm=zeros(Lmax2+1,1);
r=zeros(Lmax2+1,Q);
ltmp=sm;
for j=-Lmax:Lmax
    L1=Lmax+1+j;
    L2=N-Lmax+j;
    for q=1:Q
        x=Yct(q,:);
        y0=y(q,L1:L2);
        meanx=mean(x.^2);
        meany0=mean(y0.^2);
        if meanx>0 && meany0>0
            smw=sqrt(max(0,1-mean(x.*y0)^2/meanx/meany0));  
            r(L1,q)=meanx/mean(x.*y0);
        elseif meany0 >0
            smw=1;  
            r(L1,q)=1;
        elseif meanx > 0
            smw=sqrt(max(0,1-sum(x)^2/sum(x.^2)/length(x)));  
            r(L1,q)=1;
        else
            smw=0;
            r(L1,q)=1;
        end
        ltmp(L1)=j;
        sm(L1)=sm(L1)+weight(q)*smw;
    end
end
[tmp,ind]=sort(sm);
lag=ltmp(ind(1));
rmin=r(ind(1),:);
smmin=tmp(1);
