function [CMTmin,kcmin,Lagmin,Rmin,Jmin]=kmeansTrendM(X,K,JCmax,Lmax,weight)
%
%  input  X  : PxQxN,  weight : Qx1
%  output CMT: KxQxNT, Rmin   : PxQ
%

[P,Q,N]=size(X);
Jmin=Inf;
kcmin=zeros(P,1);
Lag=zeros(P,1);
NT=N-2*Lmax;
CMTmin=zeros(K,Q,NT);

for j=1:JCmax
    fprintf('%s\n',strcat(num2str(j),'/',num2str(JCmax)))
    %%%%%%%%%%%%
    CMT=zeros(K,Q,NT);
    %%% initialize randomly
    kc=fix(rand(P,1)*K+1);
    kcold=zeros(P,1);
    kccount=0;
    while sum(kcold~=kc)>0
        %%%%%%%%%%%%%%
        % common trend
        %%%%%%%%%%%%%%%
        for k=1:K
            Y=[];
            Py=0;
            for p=1:P
                if kc(p)==k
                    Y=[Y; squeeze(X(p,:,:))];%(Q+Q+...+Q)=Py Q x N)-matrix
                    Py=Py+1;
                end
            end
            if Py==0
                CMT(k,:,:)=zeros(Q,NT);
            else
                CMT(k,:,:)=CommonTrendM(Y,Py,Lmax,weight);
            end
        end
        %%%%%%%%%%%%%%%
        kcold=kc;
        Jv=0;
        %%
        Lag=zeros(P,1);
        R=zeros(P,Q); 
        for p=1:P
            J=zeros(K,1);
            lagtmp=J;
            Rtmp=zeros(Q,K);
            for k=1:K
                x=squeeze(CMT(k,:,:));
                y=squeeze(X(p,:,:));
                [sm,r,lag]=fun_dsmTm(x,y,Lmax,weight); % x: QxNT,  y: QxN
                J(k)=sm;
                lagtmp(k)=lag;
                Rtmp(:,k)=r';
            end
            [tmp,ind]=sort(J);
            Lag(p)=lagtmp(ind(1));
            R(p,:)=Rtmp(:,ind(1));
            kc(p)=ind(1);
            Jv=Jv+tmp(1);
        end
        kccount=kccount+1;
        if kccount>50
            disp 'kccount>50'
            % it will occur when periodic (rare but possible)
            break
        end
    end
    if Jv<Jmin
        Jmin=Jv;
        kcmin=kc;
        CMTmin=CMT;
        Lagmin=Lag;
        Rmin=R;
    end
    %%%%%%%%%%%%
end

